diff --git a/fc-solve/source/instance.h b/fc-solve/source/instance.h
index b144c2523..ef2ce7232 100644
--- a/fc-solve/source/instance.h
+++ b/fc-solve/source/instance.h
@@ -12,7 +12,8 @@
 #pragma once
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
 #include <math.h>
@@ -90,10 +91,10 @@ extern "C" {
 
 // We don't keep track of kings
 #define FCS_POS_BY_RANK_LEN (FCS_RANK_KING * FCS_POS_BY_RANK_WIDTH)
-typedef struct
-{
-    char col, height;
-} fcs_pos_by_rank_t;
+    typedef struct
+    {
+        char col, height;
+    } fcs_pos_by_rank_t;
 
 #ifndef FCS_DISABLE_SIMPLE_SIMON
 #define FCS_SS_POS_BY_RANK_WIDTH (FCS_RANK_KING + 1)
@@ -105,41 +106,41 @@ typedef struct
 #define FCS_BOTH__POS_BY_RANK__SIZE FCS_POS_BY_RANK_LEN
 #endif
 
-typedef int8_t fcs__positions_by_rank_t[FCS_BOTH__POS_BY_RANK__SIZE];
+    typedef int8_t fcs__positions_by_rank_t[FCS_BOTH__POS_BY_RANK__SIZE];
 
-/*
- * This is a linked list item that is used to implement a queue for the BFS
- * scan.
- * */
-typedef struct fcs_states_linked_list_item_struct
-{
-    fcs_collectible_state_t *s;
-    struct fcs_states_linked_list_item_struct *next;
-} fcs_states_linked_list_item_t;
+    /*
+     * This is a linked list item that is used to implement a queue for the BFS
+     * scan.
+     * */
+    typedef struct fcs_states_linked_list_item_struct
+    {
+        fcs_collectible_state_t *s;
+        struct fcs_states_linked_list_item_struct *next;
+    } fcs_states_linked_list_item_t;
 
-/*
- * Declare these structures because they will be used within
- * fc_solve_instance, and they will contain a pointer to it.
- * */
-struct fc_solve_hard_thread_struct;
-struct fc_solve_soft_thread_struct;
-struct fc_solve_instance_struct;
+    /*
+     * Declare these structures because they will be used within
+     * fc_solve_instance, and they will contain a pointer to it.
+     * */
+    struct fc_solve_hard_thread_struct;
+    struct fc_solve_soft_thread_struct;
+    struct fc_solve_instance_struct;
 
-typedef void (*fc_solve_solve_for_state_move_func_t)(
-    struct fc_solve_soft_thread_struct *, fcs_kv_state_t,
-    fcs_derived_states_list_t *);
+    typedef void (*fc_solve_solve_for_state_move_func_t)(
+        struct fc_solve_soft_thread_struct *, fcs_kv_state_t,
+        fcs_derived_states_list_t *);
 
 #ifdef FCS_SINGLE_HARD_THREAD
-typedef struct fc_solve_instance_struct fc_solve_hard_thread_t;
+    typedef struct fc_solve_instance_struct fc_solve_hard_thread_t;
 #else
 typedef struct fc_solve_hard_thread_struct fc_solve_hard_thread_t;
 #endif
 
-extern fcs_bool_t fc_solve_check_and_add_state(
-    fc_solve_hard_thread_t *, fcs_kv_state_t *, fcs_kv_state_t *);
+    extern fcs_bool_t fc_solve_check_and_add_state(
+        fc_solve_hard_thread_t *, fcs_kv_state_t *, fcs_kv_state_t *);
 
 #if (FCS_STATE_STORAGE == FCS_STATE_STORAGE_GLIB_HASH)
-extern guint fc_solve_hash_function(gconstpointer key);
+    extern guint fc_solve_hash_function(gconstpointer key);
 #endif
 #include "move_funcs_maps.h"
 
@@ -166,53 +167,54 @@ extern guint fc_solve_hash_function(gconstpointer key);
     for (; soft_thread < end_soft_thread; ++soft_thread)
 #define MOVES_GROW_BY 16
 
-typedef struct
-{
-    double weights[FCS_NUM_BEFS_WEIGHTS];
-} fcs_default_weights_t;
-typedef struct
-{
-    fcs_bool_t should_go_over_stacks;
-    double max_sequence_move_factor, cards_under_sequences_factor,
-        seqs_over_renegade_cards_factor, depth_factor,
-        num_cards_not_on_parents_factor;
-
-    double num_cards_out_lookup_table[14];
-    // The BeFS weights of the different BeFS tests. Those
-    // weights determine the commulative priority of the state.
-    fcs_default_weights_t befs_weights;
-} fc_solve_state_weighting_t;
-
-typedef enum {
-    FCS_NO_SHUFFLING,
-    FCS_RAND,
-    FCS_WEIGHTING,
-} fcs_moves_group_kind;
-
-typedef union {
-    fc_solve_solve_for_state_move_func_t f;
-    uint_fast32_t idx;
-} fcs_move_func;
-
-typedef struct
-{
-    fcs_move_func *move_funcs;
-    uint_fast32_t num;
-    fcs_moves_group_kind shuffling_type;
-    fc_solve_state_weighting_t weighting;
-} fcs_moves_group;
+    typedef struct
+    {
+        double weights[FCS_NUM_BEFS_WEIGHTS];
+    } fcs_default_weights_t;
+    typedef struct
+    {
+        fcs_bool_t should_go_over_stacks;
+        double max_sequence_move_factor, cards_under_sequences_factor,
+            seqs_over_renegade_cards_factor, depth_factor,
+            num_cards_not_on_parents_factor;
+
+        double num_cards_out_lookup_table[14];
+        // The BeFS weights of the different BeFS tests. Those
+        // weights determine the commulative priority of the state.
+        fcs_default_weights_t befs_weights;
+    } fc_solve_state_weighting_t;
+
+    typedef enum
+    {
+        FCS_NO_SHUFFLING,
+        FCS_RAND,
+        FCS_WEIGHTING,
+    } fcs_moves_group_kind;
 
-typedef struct
-{
-    uint_fast32_t num;
-    fcs_moves_group *groups;
-} fcs_moves_order;
+    typedef union {
+        fc_solve_solve_for_state_move_func_t f;
+        uint_fast32_t idx;
+    } fcs_move_func;
 
-typedef struct
-{
-    ssize_t max_depth;
-    fcs_moves_order moves_order;
-} fcs_by_depth_moves_order;
+    typedef struct
+    {
+        fcs_move_func *move_funcs;
+        uint_fast32_t num;
+        fcs_moves_group_kind shuffling_type;
+        fc_solve_state_weighting_t weighting;
+    } fcs_moves_group;
+
+    typedef struct
+    {
+        uint_fast32_t num;
+        fcs_moves_group *groups;
+    } fcs_moves_order;
+
+    typedef struct
+    {
+        ssize_t max_depth;
+        fcs_moves_order moves_order;
+    } fcs_by_depth_moves_order;
 
 #define STRUCT_CLEAR_FLAG(instance, flag) (instance)->flag = FALSE
 #define STRUCT_TURN_ON_FLAG(instance, flag) (instance)->flag = TRUE
@@ -220,360 +222,361 @@ typedef struct
 #define STRUCT_SET_FLAG_TO(instance, flag, value) (instance)->flag = (value)
 
 #ifdef FCS_RCS_STATES
-struct fcs_cache_key_info_struct
-{
-    const fcs_collectible_state_t *val_ptr;
-    fcs_state_t key;
-    /* lower_pri and higher_pri form a doubly linked list.
-     *
-     * pri == priority.
-     * */
-    struct fcs_cache_key_info_struct *lower_pri, *higher_pri;
-};
-
-typedef struct fcs_cache_key_info_struct fcs_cache_key_info_t;
-
-typedef struct
-{
+    struct fcs_cache_key_info_struct
+    {
+        const fcs_collectible_state_t *val_ptr;
+        fcs_state_t key;
+        /* lower_pri and higher_pri form a doubly linked list.
+         *
+         * pri == priority.
+         * */
+        struct fcs_cache_key_info_struct *lower_pri, *higher_pri;
+    };
+
+    typedef struct fcs_cache_key_info_struct fcs_cache_key_info_t;
+
+    typedef struct
+    {
 #if (FCS_RCS_CACHE_STORAGE == FCS_RCS_CACHE_STORAGE_JUDY)
-    Pvoid_t states_values_to_keys_map;
+        Pvoid_t states_values_to_keys_map;
 #elif (FCS_RCS_CACHE_STORAGE == FCS_RCS_CACHE_STORAGE_KAZ_TREE)
-    dict_t *kaz_tree;
+        dict_t *kaz_tree;
 #else
 #error Unknown FCS_RCS_CACHE_STORAGE
 #endif
-    fcs_compact_allocator_t states_values_to_keys_allocator;
-    fcs_int_limit_t count_elements_in_cache, max_num_elements_in_cache;
+        fcs_compact_allocator_t states_values_to_keys_allocator;
+        fcs_int_limit_t count_elements_in_cache, max_num_elements_in_cache;
 
-    fcs_cache_key_info_t *lowest_pri, *highest_pri, *recycle_bin;
-} fcs_lru_cache_t;
+        fcs_cache_key_info_t *lowest_pri, *highest_pri, *recycle_bin;
+    } fcs_lru_cache_t;
 
 #endif
 
 #ifndef FCS_WITHOUT_ITER_HANDLER
-typedef void *fcs_instance_debug_iter_output_context_t;
+    typedef void *fcs_instance_debug_iter_output_context_t;
 
-typedef void (*fcs_instance_debug_iter_output_func_t)(
-    fcs_instance_debug_iter_output_context_t, fcs_int_limit_t, int, void *,
-    fcs_kv_state_t *, fcs_int_limit_t);
+    typedef void (*fcs_instance_debug_iter_output_func_t)(
+        fcs_instance_debug_iter_output_context_t, fcs_int_limit_t, int, void *,
+        fcs_kv_state_t *, fcs_int_limit_t);
 #endif
 
-typedef struct fc_solve_soft_thread_struct fc_solve_soft_thread_t;
-typedef struct fc_solve_instance_struct fc_solve_instance_t;
+    typedef struct fc_solve_soft_thread_struct fc_solve_soft_thread_t;
+    typedef struct fc_solve_instance_struct fc_solve_instance_t;
 
-struct fc_solve_hard_thread_struct
-{
+    struct fc_solve_hard_thread_struct
+    {
 #ifndef FCS_SINGLE_HARD_THREAD
-    fc_solve_instance_t *instance;
+        fc_solve_instance_t *instance;
 #endif
 
-    struct fc_solve_soft_thread_struct *soft_threads;
+        struct fc_solve_soft_thread_struct *soft_threads;
 
 #ifndef FCS_SINGLE_HARD_THREAD
-    /*
-     * The hard thread count of how many states he checked himself. The
-     * instance num_checked_states can be confusing because other threads
-     * modify it too.
-     *
-     * Thus, the soft thread switching should be done based on this variable
-     * */
-    fcs_int_limit_t ht__num_checked_states;
-
-#endif
-    /*
-     * The maximal limit for num_checked_states.
-     * */
-    fcs_int_limit_t ht__max_num_checked_states;
-
-    /*
-     * The index for the soft-thread that is currently processed
-     * */
-    int_fast32_t st_idx;
-    /*
-     * This is the mechanism used to allocate memory for stacks, states
-     * and move stacks.
-     * */
-    fcs_compact_allocator_t allocator;
+        /*
+         * The hard thread count of how many states he checked himself. The
+         * instance num_checked_states can be confusing because other threads
+         * modify it too.
+         *
+         * Thus, the soft thread switching should be done based on this variable
+         * */
+        fcs_int_limit_t ht__num_checked_states;
+
+#endif
+        /*
+         * The maximal limit for num_checked_states.
+         * */
+        fcs_int_limit_t ht__max_num_checked_states;
+
+        /*
+         * The index for the soft-thread that is currently processed
+         * */
+        int_fast32_t st_idx;
+        /*
+         * This is the mechanism used to allocate memory for stacks, states
+         * and move stacks.
+         * */
+        fcs_compact_allocator_t allocator;
 
 #ifdef FCS_WITH_MOVES
-    /*
-     * This is a move stack that is used and re-used by the
-     * moves functions of this hard thread
-     * */
-    fcs_move_stack_t reusable_move_stack;
+        /*
+         * This is a move stack that is used and re-used by the
+         * moves functions of this hard thread
+         * */
+        fcs_move_stack_t reusable_move_stack;
 #endif
 
-    /*
-     * This is a buffer used to temporarily store the stacks of the
-     * duplicated state.
-     * */
-    DECLARE_IND_BUF_T(indirect_stacks_buffer)
+        /*
+         * This is a buffer used to temporarily store the stacks of the
+         * duplicated state.
+         * */
+        DECLARE_IND_BUF_T(indirect_stacks_buffer)
 
-    size_t prelude_num_items;
-    size_t prelude_idx;
+        size_t prelude_num_items;
+        size_t prelude_idx;
 #ifndef FCS_USE_PRECOMPILED_CMD_LINE_THEME
-    fc_solve_prelude_item *prelude;
+        fc_solve_prelude_item *prelude;
 #else
     const fc_solve_prelude_item *prelude;
 #endif
 
-    fcs_bool_t allocated_from_list;
-    int_fast32_t num_soft_threads;
+        fcs_bool_t allocated_from_list;
+        int_fast32_t num_soft_threads;
 
-    /*
-     * A counter that determines how many of the soft threads that belong
-     * to this hard thread have already finished. If it becomes
-     * num_soft_threads this thread is skipped.
-     * */
-    int num_soft_threads_finished;
+        /*
+         * A counter that determines how many of the soft threads that belong
+         * to this hard thread have already finished. If it becomes
+         * num_soft_threads this thread is skipped.
+         * */
+        int num_soft_threads_finished;
 
 #ifndef FCS_USE_PRECOMPILED_CMD_LINE_THEME
-    char *prelude_as_string;
+        char *prelude_as_string;
 #endif
-};
+    };
 
-/********************************************/
+    /********************************************/
 
-typedef struct
-{
-    int idx;
-    pq_rating_t rating;
-} fcs_rating_with_index_t;
+    typedef struct
+    {
+        int idx;
+        pq_rating_t rating;
+    } fcs_rating_with_index_t;
 
-typedef struct
-{
-    fcs_collectible_state_t *state;
-    fcs_derived_states_list_t derived_states_list;
-    size_t move_func_list_idx;
-    size_t current_state_index;
-    size_t move_func_idx;
-    size_t derived_states_random_indexes_max_size;
-    fcs_rating_with_index_t *derived_states_random_indexes;
-    fcs__positions_by_rank_t positions_by_rank;
-    fcs_game_limit_t num_vacant_stacks;
-    fcs_game_limit_t num_vacant_freecells;
-} fcs_soft_dfs_stack_item_t;
-
-typedef struct
-{
-    ssize_t max_depth;
-    fcs_moves_order move_funcs;
-} fcs_moves_by_depth_unit_t;
+    typedef struct
+    {
+        fcs_collectible_state_t *state;
+        fcs_derived_states_list_t derived_states_list;
+        size_t move_func_list_idx;
+        size_t current_state_index;
+        size_t move_func_idx;
+        size_t derived_states_random_indexes_max_size;
+        fcs_rating_with_index_t *derived_states_random_indexes;
+        fcs__positions_by_rank_t positions_by_rank;
+        fcs_game_limit_t num_vacant_stacks;
+        fcs_game_limit_t num_vacant_freecells;
+    } fcs_soft_dfs_stack_item_t;
+
+    typedef struct
+    {
+        ssize_t max_depth;
+        fcs_moves_order move_funcs;
+    } fcs_moves_by_depth_unit_t;
 
-typedef struct
-{
-    size_t num_units;
-    fcs_moves_by_depth_unit_t *by_depth_units;
-} fcs_moves_by_depth_array;
+    typedef struct
+    {
+        size_t num_units;
+        fcs_moves_by_depth_unit_t *by_depth_units;
+    } fcs_moves_by_depth_array;
 
-typedef enum {
-    FCS_SUPER_METHOD_DFS,
-    FCS_SUPER_METHOD_BEFS_BRFS,
+    typedef enum
+    {
+        FCS_SUPER_METHOD_DFS,
+        FCS_SUPER_METHOD_BEFS_BRFS,
 #ifndef FCS_DISABLE_PATSOLVE
-    FCS_SUPER_METHOD_PATSOLVE,
+        FCS_SUPER_METHOD_PATSOLVE,
 #endif
-} fcs_super_method_type_t;
-
-struct fc_solve__patsolve_thread_struct;
-struct fc_solve_soft_thread_struct
-{
-    fc_solve_hard_thread_t *hard_thread;
+    } fcs_super_method_type_t;
 
-    /*
-     * The ID of the soft thread inside the instance.
-     * Used for the state-specific flags.
-     * */
-    int id;
-
-    // The moves' order indicates which move funcs to run.
-    struct
+    struct fc_solve__patsolve_thread_struct;
+    struct fc_solve_soft_thread_struct
     {
-        size_t num;
-        fcs_by_depth_moves_order *by_depth_moves;
-    } by_depth_moves_order;
+        fc_solve_hard_thread_t *hard_thread;
 
-    /* The super-method type - can be  */
-    fcs_super_method_type_t super_method_type;
+        /*
+         * The ID of the soft thread inside the instance.
+         * Used for the state-specific flags.
+         * */
+        int id;
 
-    struct
-    {
+        // The moves' order indicates which move funcs to run.
         struct
         {
-            /*
-             * The (temporary) max depth of the Soft-DFS scans)
-             * */
-            ssize_t dfs_max_depth;
-
-            /*
-             * Soft-DFS uses a stack of fcs_soft_dfs_stack_item_t s.
-             *
-             * derived_states_list - a list of states to be checked next.
-             * Not all of them will be checked because it is possible that
-             * future states already visited them.
-             *
-             * current_state_index - the index of the last checked state
-             * in depth i.
-             *
-             * move_func_list_idx - the index of the move list that is
-             * performed. FCS performs each move separately, so
-             * states_to_check and friends will not be overpopulated.
-             *
-             * num_vacant_stacks - the number of unoccpied stacks that
-             * correspond
-             * to solution_states.
-             *
-             * num_vacant_freecells - ditto for the freecells.
-             *
-             * */
-            fcs_soft_dfs_stack_item_t *soft_dfs_info;
-
-            /* The depth of the DFS stacks */
-            ssize_t depth;
-
-            /*
-             * A pseudo-random number generator for use in the random-DFS
-             * scan
-             * */
-            fcs_rand_t rand_gen;
-
-            /*
-             * The initial seed of this random number generator
-             * */
-            int rand_seed;
-
-            /*
-             * The moves to be performed in a preprocessed form.
-             * */
-            fcs_moves_by_depth_array moves_by_depth;
-        } soft_dfs;
+            size_t num;
+            fcs_by_depth_moves_order *by_depth_moves;
+        } by_depth_moves_order;
+
+        /* The super-method type - can be  */
+        fcs_super_method_type_t super_method_type;
+
         struct
         {
-            fcs__positions_by_rank_t befs_positions_by_rank;
-            fcs_move_func *moves_list, *moves_list_end;
             struct
             {
+                /*
+                 * The (temporary) max depth of the Soft-DFS scans)
+                 * */
+                ssize_t dfs_max_depth;
+
+                /*
+                 * Soft-DFS uses a stack of fcs_soft_dfs_stack_item_t s.
+                 *
+                 * derived_states_list - a list of states to be checked next.
+                 * Not all of them will be checked because it is possible that
+                 * future states already visited them.
+                 *
+                 * current_state_index - the index of the last checked state
+                 * in depth i.
+                 *
+                 * move_func_list_idx - the index of the move list that is
+                 * performed. FCS performs each move separately, so
+                 * states_to_check and friends will not be overpopulated.
+                 *
+                 * num_vacant_stacks - the number of unoccpied stacks that
+                 * correspond
+                 * to solution_states.
+                 *
+                 * num_vacant_freecells - ditto for the freecells.
+                 *
+                 * */
+                fcs_soft_dfs_stack_item_t *soft_dfs_info;
+
+                /* The depth of the DFS stacks */
+                ssize_t depth;
+
+                /*
+                 * A pseudo-random number generator for use in the random-DFS
+                 * scan
+                 * */
+                fcs_rand_t rand_gen;
+
+                /*
+                 * The initial seed of this random number generator
+                 * */
+                int rand_seed;
+
+                /*
+                 * The moves to be performed in a preprocessed form.
+                 * */
+                fcs_moves_by_depth_array moves_by_depth;
+            } soft_dfs;
+            struct
+            {
+                fcs__positions_by_rank_t befs_positions_by_rank;
+                fcs_move_func *moves_list, *moves_list_end;
                 struct
                 {
-                    /*
-                     * A linked list that serves as the queue for the BFS
-                     * scan.
-                     * */
-                    fcs_states_linked_list_item_t *bfs_queue;
-                    /*
-                     * The last item in the linked list, so new items can be
-                     * added at
-                     * it, thus making it a queue.
-                     * */
-                    fcs_states_linked_list_item_t *bfs_queue_last_item;
-                    /*
-                     * A linked list of items that were freed from
-                     * the queue and should be reused before allocating new
-                     * items.
-                     * */
-                    fcs_states_linked_list_item_t *recycle_bin;
-                } brfs;
-                struct
-                {
-                    /*
-                     * The priority queue of the BeFS scan
-                     * */
-                    pri_queue_t pqueue;
-                    fc_solve_state_weighting_t weighting;
-                } befs;
-            } meth;
-            /*
-             * The first state to be checked by the scan. It is a kind of
-             * bootstrap for the algorithm.
-             * */
-            fcs_collectible_state_t *first_state_to_check;
-        } befs;
-    } method_specific;
-
-    fcs_bool_t FCS_SOFT_THREAD_IS_FINISHED, FCS_SOFT_THREAD_INITIALIZED,
-        FCS_SOFT_THREAD_IS_A_COMPLETE_SCAN;
-
-    // The numbers of vacant stacks and freecells in the current state - is
-    // read by the move functions in freecell.c .
-    fcs_game_limit_t num_vacant_stacks, num_vacant_freecells;
-
-    /*
-     * The number of iterations with which to process this scan
-     * */
-    fcs_int_limit_t checked_states_step;
+                    struct
+                    {
+                        /*
+                         * A linked list that serves as the queue for the BFS
+                         * scan.
+                         * */
+                        fcs_states_linked_list_item_t *bfs_queue;
+                        /*
+                         * The last item in the linked list, so new items can be
+                         * added at
+                         * it, thus making it a queue.
+                         * */
+                        fcs_states_linked_list_item_t *bfs_queue_last_item;
+                        /*
+                         * A linked list of items that were freed from
+                         * the queue and should be reused before allocating new
+                         * items.
+                         * */
+                        fcs_states_linked_list_item_t *recycle_bin;
+                    } brfs;
+                    struct
+                    {
+                        /*
+                         * The priority queue of the BeFS scan
+                         * */
+                        pri_queue_t pqueue;
+                        fc_solve_state_weighting_t weighting;
+                    } befs;
+                } meth;
+                /*
+                 * The first state to be checked by the scan. It is a kind of
+                 * bootstrap for the algorithm.
+                 * */
+                fcs_collectible_state_t *first_state_to_check;
+            } befs;
+        } method_specific;
+
+        fcs_bool_t FCS_SOFT_THREAD_IS_FINISHED, FCS_SOFT_THREAD_INITIALIZED,
+            FCS_SOFT_THREAD_IS_A_COMPLETE_SCAN;
+
+        // The numbers of vacant stacks and freecells in the current state - is
+        // read by the move functions in freecell.c .
+        fcs_game_limit_t num_vacant_stacks, num_vacant_freecells;
+
+        /*
+         * The number of iterations with which to process this scan
+         * */
+        fcs_int_limit_t checked_states_step;
 
 #ifndef FCS_USE_PRECOMPILED_CMD_LINE_THEME
-    // A string that serves as an identification for the user.
-    char name[FCS_MAX_IDENT_LEN];
+        // A string that serves as an identification for the user.
+        char name[FCS_MAX_IDENT_LEN];
 #endif
 
 #ifndef FCS_ENABLE_PRUNE__R_TF__UNCOND
-    /*
-     * Whether pruning should be done.
-     * This variable is temporary - there should be a better pruning
-     * abstraction with several optional prunes.
-     * */
-    fcs_bool_t enable_pruning;
+        /*
+         * Whether pruning should be done.
+         * This variable is temporary - there should be a better pruning
+         * abstraction with several optional prunes.
+         * */
+        fcs_bool_t enable_pruning;
 #endif
 
 #ifndef FCS_DISABLE_PATSOLVE
-    /*
-     * The patsolve soft_thread that is associated with this soft_thread.
-     * */
-    struct fc_solve__patsolve_thread_struct *pats_scan;
-#endif
-    /*
-     * Differentiates between SOFT_DFS and RANDOM_DFS.
-     * */
-    fcs_bool_t master_to_randomize;
-    fcs_bool_t is_befs
+        /*
+         * The patsolve soft_thread that is associated with this soft_thread.
+         * */
+        struct fc_solve__patsolve_thread_struct *pats_scan;
+#endif
+        /*
+         * Differentiates between SOFT_DFS and RANDOM_DFS.
+         * */
+        fcs_bool_t master_to_randomize;
+        fcs_bool_t is_befs
 #ifdef FCS_WITH_MOVES
-        ,
-        is_optimize_scan
+            ,
+            is_optimize_scan
 #endif
-        ;
-};
+            ;
+    };
 
-struct fc_solve_instance_struct
-{
+    struct fc_solve_instance_struct
+    {
 // The parameters of the game - see the declaration of fcs_game_type_params_t .
 #ifndef FCS_FREECELL_ONLY
-    fcs_game_type_params_t game_params;
+        fcs_game_type_params_t game_params;
 #ifndef FCS_DISABLE_PATSOLVE
-    fcs_card_t game_variant_suit_mask;
-    fcs_card_t game_variant_desired_suit_value;
+        fcs_card_t game_variant_suit_mask;
+        fcs_card_t game_variant_desired_suit_value;
 #endif
 #endif
 
-    /* The number of states that were checked by the solving algorithm. */
-    fcs_int_limit_t i__num_checked_states;
+        /* The number of states that were checked by the solving algorithm. */
+        fcs_int_limit_t i__num_checked_states;
 
 #ifndef FCS_WITHOUT_MAX_NUM_STATES
-    /*
-     * Limit for the maximal number of checked states.
-     * max_num_checked_states is useful because it can limit the amount of
-     * consumed memory (and time).
-     *
-     * This is the effective number that enables the process to work without
-     * checking if it's zero.
-     *
-     * Normally should be used instead.
-     * */
-    fcs_int_limit_t effective_max_num_checked_states;
+        /*
+         * Limit for the maximal number of checked states.
+         * max_num_checked_states is useful because it can limit the amount of
+         * consumed memory (and time).
+         *
+         * This is the effective number that enables the process to work without
+         * checking if it's zero.
+         *
+         * Normally should be used instead.
+         * */
+        fcs_int_limit_t effective_max_num_checked_states;
 #endif
 #ifndef FCS_DISABLE_NUM_STORED_STATES
-    fcs_int_limit_t effective_max_num_states_in_collection;
+        fcs_int_limit_t effective_max_num_states_in_collection;
 #ifndef FCS_WITHOUT_TRIM_MAX_STORED_STATES
-    fcs_int_limit_t effective_trim_states_in_collection_from;
+        fcs_int_limit_t effective_trim_states_in_collection_from;
 #endif
 #endif
-    fc_solve_seq_cards_power_type_t initial_cards_under_sequences_value;
+        fc_solve_seq_cards_power_type_t initial_cards_under_sequences_value;
 /*
  * tree is the balanced binary tree that is used to store and index
  * the checked states.
  *
  * */
 #if (FCS_STATE_STORAGE == FCS_STATE_STORAGE_LIBREDBLACK_TREE)
-    struct rbtree *tree;
+        struct rbtree *tree;
 #elif (FCS_STATE_STORAGE == FCS_STATE_STORAGE_JUDY)
     Pvoid_t judy_array;
 #elif (FCS_STATE_STORAGE == FCS_STATE_STORAGE_LIBAVL2_TREE)
@@ -589,7 +592,7 @@ struct fc_solve_instance_struct
  * states of the scan.
  * */
 #if (FCS_STATE_STORAGE == FCS_STATE_STORAGE_GLIB_HASH)
-    GHashTable *hash;
+        GHashTable *hash;
 #elif (FCS_STATE_STORAGE == FCS_STATE_STORAGE_INTERNAL_HASH)
     fc_solve_hash_t hash;
 #elif (FCS_STATE_STORAGE == FCS_STATE_STORAGE_GOOGLE_DENSE_HASH)
@@ -602,49 +605,50 @@ struct fc_solve_instance_struct
  * used.
  * */
 #if (FCS_STACK_STORAGE == FCS_STACK_STORAGE_INTERNAL_HASH)
-    fc_solve_hash_t stacks_hash;
+        fc_solve_hash_t stacks_hash;
 #elif (FCS_STACK_STORAGE == FCS_STACK_STORAGE_LIBAVL2_TREE)
-    fcs_libavl2_stacks_tree_table_t *stacks_tree;
+        fcs_libavl2_stacks_tree_table_t *stacks_tree;
 #elif (FCS_STACK_STORAGE == FCS_STACK_STORAGE_LIBREDBLACK_TREE)
-    struct rbtree *stacks_tree;
+        struct rbtree *stacks_tree;
 #elif (FCS_STACK_STORAGE == FCS_STACK_STORAGE_GLIB_TREE)
-    GTree *stacks_tree;
+        GTree *stacks_tree;
 #elif (FCS_STACK_STORAGE == FCS_STACK_STORAGE_GLIB_HASH)
-    GHashTable *stacks_hash;
+        GHashTable *stacks_hash;
 #elif (FCS_STACK_STORAGE == FCS_STACK_STORAGE_GOOGLE_DENSE_HASH)
-    fcs_columns_google_hash_handle_t stacks_hash;
+        fcs_columns_google_hash_handle_t stacks_hash;
 #elif (FCS_STACK_STORAGE == FCS_STACK_STORAGE_JUDY)
-    Pvoid_t stacks_judy_array;
+        Pvoid_t stacks_judy_array;
 #else
 #error FCS_STACK_STORAGE is not set to a good value.
 #endif
 #endif
 
-    fcs_collectible_state_t *list_of_vacant_states;
+        fcs_collectible_state_t *list_of_vacant_states;
 /*
  * Storing using Berkeley DB is not operational for some reason so
  * pay no attention to it for the while
  * */
 #if (FCS_STATE_STORAGE == FCS_STATE_STORAGE_DB_FILE)
-    DB *db;
+        DB *db;
 #endif
 
 #ifndef FCS_HARD_CODE_CALC_REAL_DEPTH_AS_FALSE
-    fcs_bool_t FCS_RUNTIME_CALC_REAL_DEPTH;
+        fcs_bool_t FCS_RUNTIME_CALC_REAL_DEPTH;
 #endif
 #ifndef FCS_HARD_CODE_REPARENT_STATES_AS_FALSE
-    fcs_bool_t FCS_RUNTIME_TO_REPARENT_STATES_REAL;
+        fcs_bool_t FCS_RUNTIME_TO_REPARENT_STATES_REAL;
 #endif
 #ifndef FCS_HARD_CODE_SCANS_SYNERGY_AS_TRUE
-    fcs_bool_t FCS_RUNTIME_SCANS_SYNERGY;
+        fcs_bool_t FCS_RUNTIME_SCANS_SYNERGY;
 #endif
 #ifndef FCS_HARD_CODE_REPARENT_STATES_AS_FALSE
-    fcs_bool_t FCS_RUNTIME_TO_REPARENT_STATES_PROTO;
+        fcs_bool_t FCS_RUNTIME_TO_REPARENT_STATES_PROTO;
 #endif
-    ;
+        ;
 #ifdef FCS_WITH_MOVES
-    fcs_bool_t FCS_RUNTIME_OPTIMIZE_SOLUTION_PATH,
-        FCS_RUNTIME_IN_OPTIMIZATION_THREAD, FCS_RUNTIME_OPT_TESTS_ORDER_WAS_SET;
+        fcs_bool_t FCS_RUNTIME_OPTIMIZE_SOLUTION_PATH,
+            FCS_RUNTIME_IN_OPTIMIZATION_THREAD,
+            FCS_RUNTIME_OPT_TESTS_ORDER_WAS_SET;
 #endif
 
 /*
@@ -654,16 +658,16 @@ struct fc_solve_instance_struct
  * */
 #ifndef FCS_DISABLE_NUM_STORED_STATES
 #ifndef FCS_WITHOUT_TRIM_MAX_STORED_STATES
-    fcs_int_limit_t active_num_states_in_collection;
+        fcs_int_limit_t active_num_states_in_collection;
 #endif
-    fcs_int_limit_t num_states_in_collection;
+        fcs_int_limit_t num_states_in_collection;
 #endif
 
 #ifdef FCS_SINGLE_HARD_THREAD
-    struct fc_solve_hard_thread_struct hard_thread;
+        struct fc_solve_hard_thread_struct hard_thread;
 #ifdef FCS_WITH_MOVES
-    fcs_bool_t is_optimization_st;
-    struct fc_solve_soft_thread_struct optimization_soft_thread;
+        fcs_bool_t is_optimization_st;
+        struct fc_solve_soft_thread_struct optimization_soft_thread;
 #endif
 #else
     uint_fast32_t num_hard_threads;
